/**
 * DICK, A TCP Network Scanner
 *
 * Copyright (C) 2008 by  
 * Jeffrey Fulmer - <jeff@joedog.org>, et al. 
 * This file is distributed as part of Dick
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * 
 *
 */
#ifdef  HAVE_CONFIG_H
# include <config.h> 
#endif/*HAVE_CONFIG_H*/

#include <stdio.h>
#include <stdlib.h>

#ifdef STDC_HEADERS
# include <string.h>
#else
# ifndef HAVE_STRCHR
#  define strchr index
#  define strrchr rindex
# endif
char *strchr (), *strrchr ();
# ifndef HAVE_MEMCPY
#  define memcpy(d, s, n) bcopy ((s), (d), (n))
#  define memmove(d, s, n) bcopy ((s), (d), (n))
# endif
#endif

#include <version.h>
#ifdef __CYGWIN__
# include <getopt.h>
#else
# include <joedog/getopt.h>
#endif

#include <joedog/defs.h>
#include <joedog/boolean.h>
#include <joedog/joedog.h>

#include <conf.h>
#include <check.h>
#include <resource.h>

/**
 * long options, std options struct
 */
static struct option long_options[] =
{
  { "version",    no_argument,       NULL, 'V' },
  { "help",       no_argument,       NULL, 'h' },
  { "config",     no_argument,       NULL, 'C' },
  { "verbose",    no_argument,       NULL, 'v' },
  { "icmp",       no_argument,       NULL, 'I' },
  { "tcp",        no_argument,       NULL, 'T' },
  { "lower",      required_argument, NULL, 'l' },
  { "upper",      required_argument, NULL, 'u' },
  { "timeout",    required_argument, NULL, 't' },
  { "rcfile",     required_argument, NULL, 'R' },
  { "debug",      no_argument,       NULL, 'd' },
};

/**
 * version_string is defined in version.c adding it to a 
 * separate file allows us to parse it in configure.  
 */
void 
display_version(BOOLEAN b) {   
  char name[128];

  memset(name, 0, sizeof name);
  strncpy(name, program_name, strlen(program_name));

  if(b == TRUE){
    printf("%s %s\n\n%s\n", uppercase(name, strlen(name)), version_string, copyright);
    exit(EXIT_SUCCESS);
  } else {
    printf("%s %s\n", uppercase(name, strlen(name)), version_string);
  }
}

/**
 * display help section to STDOUT and exit
 */
void
display_help(int status)
{
  display_version(FALSE);
  printf("Usage: %s [options] HOST\n", program_name);
  printf("       %s [options] -n NETWORK\n", program_name);
  printf("Options:\n"                    );
  puts("  -V, --version           VERSION, prints version number to screen.");
  puts("  -h, --help              HELP, prints this section.");
  puts("  -v, --verbose           VERBOSE, prints notification to screen.");
  puts("  -C, --config            CONFIG, displays the default settings and exits");
  puts("  -n, --net               NETSCAN, scan a network for hosts.");
  puts("  -I, --icmp              use ICMP pings instead of tcp port discovery on a netscan (default)");
  puts("  -T, --tcp               use TCP port discovery on a netscan");
  puts("  -l, --lower=NUM         LOWER, set the lower range of a port scan (default: 1)");
  puts("  -u, --upper=NUM         UPPER, set the upper range of a port scan (default: 1024)");
  puts("  -t, --timeout=NUM       TIMEOUT, set the tcp timeout for the scan (default: 1 seconds)");
  puts("  -R, --rcfile=FILE       RCFILE, set an alternative dickrc file (default: $HOME/.dickrc)");
  puts("  -D, --debug             DEBUG, print verbose error messages");
  exit(status);
}

void
parse_cmdline_rc(CONF C, int argc, char *argv[]) {
  int a = 0;

  while(a > -1){
    a = getopt_long(argc, argv,"VChvdnpl:u:t:TR:", long_options, (int*)0);
    if(a == 'R'){
      set_rcfile(C, optarg);
      a = -1;
      if(!strncasecmp(optarg,"generate",8)){
        generate_rcfile();
        exit(0);
      }
    }
  }
  optind = 0;
}


/**
 * parses command line arguments and assigns values to run time
 * variables. relies on GNU getopts included with this distribution.  
 */
void
parse_cmdline(CONF C, int argc, char *argv[]) {
  int c = 0;
  int nargs;
  while((c = getopt_long(argc, argv, "VChvdnpl:u:t:TR:", long_options, (int *)0)) != EOF){
  switch(c){
      case 'V':
        display_version(TRUE);
        break;
      case 'h':
        display_help(EXIT_SUCCESS);
      case 'v':
        set_verbose(C, TRUE);
        break;
      case 'C':
        show(C, TRUE);
        break;
      case 'd':
        set_debug(C, TRUE);
        break;
      case 'l':
        set_lower(C, atoi(optarg));
        break;
      case 'u':
        set_upper(C, atoi(optarg));
        break;
      case 'n':
        set_type(C, NET);
        break;
      case 'I':
        set_protocol(C, ICMP, TRUE);
        break;
      case 'T':
        set_protocol(C, TCP, TRUE);
        break;
      case 't':
        set_timeout(C, atoi(optarg));
        break;
    } /* end of switch */
  }   /* end of while  */
  nargs = argc - optind;
  if(nargs)
    set_address(C, argv[argc-1]);
  if(get_address(C)==NULL){
    display_help(EXIT_FAILURE); 
  }
  return;
} /* end of parse_cmdline */

int
main(int argc, char *argv[])
{
  CONF C   = new_conf();
  parse_cmdline_rc(C, argc, argv);
  parse_rcfile(C);
  parse_cmdline(C, argc, argv);
 
  printf("RCFILE: %s\n", get_rcfile(C)); 
  switch(get_type(C)){
    case PORT:
      portscan(C);
      break;
    case NET:
      netscan(C);
      break;
    default:
      portscan(C);
      break;
  }
  exit(EXIT_SUCCESS);
} /* end of int main **/


