#include <stdlib.h>
#include <string.h>
#include <network.h>

#define ADDRESS_LENGTH 16

struct NETWORK_T
{
  int  octet[4];
  char *address;
};

private BOOLEAN __setup(NETWORK this, char *addr);

NETWORK
new_network(char *addr)
{
  NETWORK this;
  this = xcalloc(sizeof(*this),1);
  if(__setup(this, addr)==FALSE){
    return NULL;
  }
  return this;
}

void
network_destroy(NETWORK this)
{
  xfree(this->address);
  xfree(this);
  return;
}

char *
network_get_address(NETWORK this){
  return this->address;
}

int 
network_get_octet(NETWORK this, OCTET o){
  return this->octet[o];
}


private BOOLEAN
__setup(NETWORK this, char *addr){
  int i   = 0;
  int ret = 0;
  char octet[4][4];
  char ignore;
  this->address = xmalloc(ADDRESS_LENGTH);
  memset(this->address, '\0', ADDRESS_LENGTH);
  
  ret = sscanf(
    addr,
    "%3[0123456789]."
    "%3[0123456789]."
    "%3[0123456789]."
    "%3[0123456789]%c",
    octet[0], octet[1], octet[2], octet[3], &ignore
  );

  i = this->octet[0] = atoi(octet[0]); 
  if(i < 10 || i > 247){ 
    fprintf(stderr, "The first octet (%d) is out of range in network: %s\n", i, addr); 
    return FALSE;
  }

  i = this->octet[1] = atoi(octet[1]); 
  if(i < 0 || i > 254){ 
    fprintf(stderr, "The second octet (%d) is out of range in network: %s\n", i, addr); 
    return FALSE;
  }

  i = this->octet[2] = atoi(octet[2]); 
  if(i < 0 || i > 254){ 
    fprintf(stderr, "The third octet (%d) is out of range in network: %s\n", i, addr); 
    return FALSE;
  }

  i = this->octet[3] = atoi(octet[3]); 
  if(i < 0 || i > 254){ 
    fprintf(stderr, "The fourth octet (%d) is out of range in network: %s\n", i, addr); 
    return FALSE;
  }

  snprintf(this->address,ADDRESS_LENGTH,"%d.%d.%d.%d",this->octet[0],this->octet[1],this->octet[2],this->octet[3]);

  return TRUE;
}

