#ifndef __SOCKET_H
#define __SOCKET_H

#include <stdio.h>
#include <unistd.h>

#include <joedog/joedog.h>
#include <joedog/defs.h>
#include <joedog/boolean.h>

typedef enum { ICMP, TCP } PROTOCOL;

typedef struct SOCKET_T *SOCKET;

SOCKET   new_socket(char *host, int port, PROTOCOL protocol);
SOCKET   socket_destroy(SOCKET this);
BOOLEAN  socket_close(SOCKET this);
BOOLEAN  socket_check(SOCKET this);
void     socket_set_debug(SOCKET this, BOOLEAN debug);
void     socket_set_port(SOCKET this, int port);
void     socket_set_timeout(SOCKET this, int timeout);
int      socket_get_port(SOCKET this);
int      socket_get_timeout(SOCKET this);
char     *socket_get_hostname(SOCKET this);
char     *socket_get_ptr(SOCKET this);

#endif/*__SOCKET_H*/
